var REPORT_SUMMARY_TEMPLATE= exports.REPORT_SUMMARY_TEMPLATE="<html>\n    <head>\n        <title>Test Results</title>\n        <script language=\"javascript\" type=\"text/javascript\"><!--\n            <%=DYGRAPH_SOURCE%>\n            function jsonToTable(json) {\n                var txt = \"\";\n                for (var i in json)\n                    txt += \"<tr><td class=label>\" + i + \"</td><td>\" + json[i] + \"</td></tr>\";\n                return \"<table>\" + txt + \"</table>\";\n            };\n        --></script>\n        <style><!--\n            body { margin: 0px; font: 13px Arial, Helvetica, sans-serif; }\n            h1 { font-size: 2.4em; }\n            p, ol, ul { line-height: 30%; }\n            a:hover { text-decoration: none; }\n            #main { float:left; width: 740px; }\n            #sidebar { float:right; width: 260px; height: 100%; border-left: #BFC9AE solid 1px; margin-left: 10px; padding-left: 10px;}\n            #header { width: 100%; height: 100px; margin: 0px auto; color: #FFFFFF; background: #699C4D; border: 3px solid darkgreen; border-style: none none solid none;}\n            #header h1 { width: 1024; padding: 25px 0px 0px 0px; margin: 0px auto; font-weight: normal; }\n            #header p { width: 1024; padding: 15px 0px 0px 0px; margin: 0px auto; }\n            #page { width: 1024px; margin: 0px auto; padding: 30px 0px; }\n            .post { margin: 0px 0px 30px 0px; }\n            .post h1, .post h2 { margin: 0px; padding: 0px 0px 5px 0px; border-bottom: #BFC9AE solid 1px; color: #232F01; }\n            .entry { margin: 10px 0px 20px 0px; }\n            #footer { clear: both; width: 1024px; height: 50px; margin: 0px auto 30px auto; color: #FFFFFF; background: #699C4D; }\n            #footer p { padding: 19px 0px 0px 0px; text-align: center; line-height: normal; font-size: smaller; }\n            #footer a { color: #FFFFFF; }\n            .statsTable table { font-size: small; font-variant: small-caps; border-spacing: 10px 1px; }\n            .statsTable .label { text-align:right; }\n        --></style>\n    </head>\n\n    <body>\n        <div id=\"header\">\n            <h1>Test Results</h1>\n            <p id=\"timestamp\"><%=new Date()%></p>\n        </div>\n        <div id=\"page\">\n            <div id=\"main\"></div>\n            <div id=\"sidebar\">\n                <div class=\"post\">\n                    <h2>Cumulative</h2>\n                    <div id=\"summaries\" class=\"entry\"></div>\n                </div>\n            </div>\n        </div>\n        <div id=\"footer\"><p>generated with <a href=\"http://github.com/benschmaus/nodeload\">nodeload</a></p></div>\n    </body>\n\n    <script id=\"source\" language=\"javascript\" type=\"text/javascript\">\n        var raw_reports;\n        function update(reports) {\n            var main = document.getElementById(\"main\"), summaries = document.getElementById(\"summaries\");\n            document.getElementById(\"timestamp\").innerHTML = new Date();\n            raw_reports = reports;\n            reports.forEach(function(report) {\n                \n                var summary = document.getElementById(\"reportSummary\" + report.uid);\n                if (!summary) {\n                    var summary = document.createElement(\"p\");\n                    summary.setAttribute(\"id\", \"reportSummary\" + report.uid);\n                    summary.setAttribute(\"class\", \"statsTable\");\n                    summaries.appendChild(summary);\n                }\n                summary.innerHTML = jsonToTable(report.summary);\n                \n                for (var j in report.charts) {\n                    var chart = report.charts[j];\n\n                    if (graphs[chart.uid]) {\n                        graphs[chart.uid].updateOptions({\"file\": chart.rows, labels: chart.columns});\n                    } else {\n                        var newchart = document.createElement(\"div\");\n                        newchart.setAttribute(\"class\", \"post\");\n                        newchart.innerHTML = [].concat(\n                            '<h2>', report.name, ': ', chart.name, '</h2>',\n                            '<div class=\"entry\" style=\"width:100%;float:left\">',\n                                '<div id=\"chart', chart.uid, '\" style=\"float:left;width:660px;height:200px;\"></div>',\n                                '<div id=\"chartlegend', chart.uid, '\" style=\"float:left;width:80px;height:200px;\"></div>',\n                            '</div>'\n                        ).join('');\n                        main.appendChild(newchart);\n                        graphs[chart.uid] = new Dygraph(\n                            document.getElementById(\"chart\" + chart.uid),\n                            chart.rows,\n                            {\n                                labelsDiv: document.getElementById(\"chartlegend\" + chart.uid),\n                                labelsSeparateLines: true,\n                                labels: chart.columns\n                            });\n                    }\n                }\n            });\n        }\n\n        if(navigator.appName == \"Microsoft Internet Explorer\") { http = new ActiveXObject(\"Microsoft.XMLHTTP\"); } else { http = new XMLHttpRequest(); }\n\n        setInterval(function() {\n            http.open(\"GET\", \"/reports\");\n            http.onreadystatechange=function() { \n                if (http.readyState == 4 && http.status == 200) {\n                    update(JSON.parse(http.responseText));\n                }\n            }\n            http.send(null);\n        }, <%=refreshPeriodMs%>);\n        \n        graphs = {};\n        update(<%=JSON.stringify(reports)%>);\n    </script>\n</html>";
